---
title: Using the Media Capabilities API
slug: Web/API/Media_Capabilities_API/Using_the_Media_Capabilities_API
tags:
  - API
  - Audio
  - Guide
  - Intermediate
  - Media
  - Media Capabilities
  - Media Capabilities API
  - Video
  - capabilities
---
<div>{{APIRef("Media Capabilities API")}}</div>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/Media_Capabilities_API">Media Capabilities API</a> provides several key features to help you better decide how to handle media, but also to determine how well media is being handled, in real time.</span> These features include:</p>

<ul>
 <li>The ability to query the browser to determine its ability to encode or decode media given a specified set of encoding parameters. These parameters may include the codecs, resolutions, bit rates, frame rates, and other such details. With the Media Capabilities API, you can determine not just if the browser can support a given format, but whether or not it can do so efficiently and smoothly. In short, this API replaces—and improves upon—the {{domxref("MediaSource")}} method {{domxref("MediaSource.isTypeSupported", "isTypeSupported()")}} or the {{domxref("HTMLMediaElement")}} method {{domxref("HTMLMediaElement.canPlayType","canPlayType()")}}.</li>
 <li>More and more finely-detailed information about the display's properties, so that informed decisions can be made when choosing the best format to play on the user's device. For example, you can use the API to ensure that you don't try to play High Dynamic Range (HDR) content on a Standard Dynamic Range (SDR) screen.</li>
 <li>Support for getting real-time feedback about the playback of media, so your code can make informed decisions about adapting the stream's quality or other settings to manage the user's perceived media performance and quality. One feature of this is the ability to detect when the device switches GPUs, so you can make appropriate adjustments based on the new GPU's capabilities.</li>
</ul>

<div class="notecard note">
<p><strong>Note:</strong> The display capabilities functionality mentioned in the third point above have not yet appeared in any browser. They will be a useful feature of the API once available, but there is a high probability of the display capabilities functionality changing a great deal before browser implementations arrive.</p>
</div>

<h2 id="The_MediaCapabilities_interface">The MediaCapabilities interface</h2>

<p>The {{domxref("MediaCapabilities")}} is available using the {{domxref("Navigator.mediaCapabilities", "mediaCapabilities")}} property which is provided by both the <code>navigator</code> object and the {{domxref("WorkerNavigator")}} object; in other words, the Media Capabilities API is available both on the main thread and from workers.</p>

<p>If the object exists, Media Capabilities API is available. You can, therefore, test for the presence of the API  like so:</p>

<pre class="brush: js">if ("mediaCapabilities" in navigator) {
  // mediaCapabilities is available
} else {
  // mediaCapabilities IS NOT available
}
</pre>

<p>Taking video as an example, to obtain information about video decoding abilities, you create a video decoding configuration which you pass as a parameter to  {{domxref("MediaCapabilities.decodingInfo()")}} method. This returns a promise that fulfills with information about the media capabilities as to whether the video can be decoded, and whether decoding will be smooth and power efficient. You can also test audio decoding as well as video and audio encoding.</p>

<h3 id="Creating_a_video_decoding_configuration">Creating a video decoding configuration</h3>

<p>The {{domxref("MediaCapabilities.decodingInfo()")}} method takes as a parameter a media decoding configuration. There are very specific ways to go about creating the configuration defined by the {{domxref("MediaDecodingConfiguration")}} dictionary.</p>

<p>In our example, we are testing the decoding capabilities of a video configuration. The configuration requires the type of media being tested — e.g. a plain <code>file</code> or {{domxref("MediaSource")}} — and a {{domxref("VideoConfiguration")}} including values for the<strong> </strong><code>contentType</code>, <code>width</code>, <code>height</code>, <code>bitrate</code>, and <code>framerate</code><strong>:</strong></p>

<ul>
 <li>The <code>contentType</code> must be a string specifying a <a href="/en-US/docs/Web/Media/Formats/Video_codecs">valid video MIME type</a>.</li>
 <li>The <code>width</code> and <code>height</code> are the horizontal and vertical dimensions of the video; these are also used to determine the aspect ratio.</li>
 <li>The <code>bitrate</code> is the number of bits used to encode one second of video.</li>
 <li>The <code>framerate</code> is the number of frames which are played per second of time when playing the video.</li>
</ul>

<pre class="brush: js">const videoConfiguration = {
  type: "file",
    video: {
      contentType: "video/webm;codecs=vp8",
      width: 800,
      height: 600,
      bitrate: 10000,
      framerate: 15
   }
};</pre>

<p>Had we been querying the decodability of an audio file, we would create an audio configuration including the number of channels and sample rate, leaving out the properties that apply only to video—namely, the dimensions and the frame rate:</p>

<pre class="brush: js">const audioConfiguration = {
  type: "file",
    audio: {
      contentType: "audio/ogg",
      channels: 2,
      bitrate: 132700,
      samplerate: 5200
   }
};</pre>

<p>Had we been testing encoding capabilities, we would have created a {{domxref("MediaEncodingConfiguration")}}, which requires the type of media being tested — either <code>record</code> (for recording media, i.e. a {{domxref("MediaRecorder")}} object) or <code>transmission</code> (for media transmitted over electronic means like <a href="/en-US/docs/Web/API/RTCPeerConnection" title="The RTCPeerConnection interface represents a WebRTC connection between the local computer and a remote peer. It provides methods to connect to a remote peer, maintain and monitor the connection, and close the connection once it's no longer needed."><code>RTCPeerConnection</code></a>) — plus either an audio or video configuration as described above.</p>

<h3 id="Querying_the_browser_about_decoding_abilities">Querying the browser about decoding abilities</h3>

<p>Now that we've created a video decoding configuration we can pass it as a paramater of the {{domxref("MediaCapabilities.decodingInfo", "decodingInfo()")}} method to determine if a video matching this configuration would be decodable and if the playback would be smooth and power efficient.</p>

<pre class="brush: js language-js">var promise = navigator.mediaCapabilities.decodingInfo(videoConfiguration);</pre>

<p>The <code>decodingInfo()</code> and {{domxref("MediaCapabilities.encodingInfo", "encodingInfo()")}} methods both return promises. Once the promises state is fulfilled, you can access the <span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="objectBox objectBox-object"><span class="objectTitle">{{domxref("MediaCapabilitiesInfo")}} interface's <code>supported</code>, <code>smooth</code>, and <code>powerEfficient</code> properties.</span></span></span></span></span></p>

<h3 id="Handling_the_response">Handling the response</h3>

<p>Instead of the assigning the promise to a variable, we can output the values returned by the promise to the console:</p>

<pre class="brush: js language-js">navigator.mediaCapabilities.decodingInfo(videoConfiguration).then(result =&gt; {
  console.log('This configuration is ' +
    (result.supported ? '' : 'not ') + 'supported, ' +
    (result.smooth ? '' : 'not ') + 'smooth, and ' +
    (result.powerEfficient ? '' : 'not ') + 'power efficient.')
});</pre>

<p>The response provided is defined by the  {{domxref("MediaCapabilitiesInfo")}} interface.</p>

<h2 id="Handling_errors">Handling errors</h2>

<p>In our video decoding example, a <code>TypeError</code> would be raised if the media configuration passed to the {{domxref("MediaCapabilities.decodingInfo", "decodingInfo()")}} method was invalid. There are a few reasons why an error might occur, including:</p>

<ul>
 <li>The specified <code>type</code> isn't one of the two permtited values: <code>file</code> or <code>media-source</code></li>
 <li>The <code>contentType</code> given is</li>
</ul>

<p>The error can be due to the <code>type</code> not being one of the two possible values, the <code>contentType</code> not being a valid codec MIME type, or invalid or omitted definitions required in the {{domxref("VideoConfiguration")}}.</p>

<pre class="brush: js;">navigator.mediaCapabilities.decodingInfo(videoConfiguration).then(
  console.log('It worked')
).catch(error =&gt;
  console.log('It failed: ' + error)
);</pre>

<h2 id="Media_Capabilities_live_example">Media Capabilities live example</h2>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">li { margin : 1em; }
</pre>

<h3 id="HTML">HTML</h3>

<pre class="brush: html;">&lt;form&gt;
&lt;p&gt;Select your video configuration and find out if this browser supports the codec,
and whether decoding will be smooth and power efficient:&lt;/p&gt;
  &lt;ul&gt;
  &lt;li&gt;
    &lt;label for="codec"&gt;Select a codec&lt;/label&gt;
    &lt;select id="codec"&gt;
      &lt;option&gt;video/webm; codecs=vp8&lt;/option&gt;
      &lt;option&gt;video/webm; codecs=vp9&lt;/option&gt;
      &lt;option&gt;video/mp4; codecs=avc1&lt;/option&gt;
      &lt;option&gt;video/mp4; codecs=avc1.420034&lt;/option&gt;
      &lt;option&gt;video/ogg; codecs=theora&lt;/option&gt;
      &lt;option&gt;invalid&lt;/option&gt;
    &lt;/select&gt;
  &lt;/li&gt;
  &lt;li&gt;
    &lt;label for="size"&gt;Select a size&lt;/label&gt;
    &lt;select id="size"&gt;
      &lt;option&gt;7680x4320&lt;/option&gt;
      &lt;option&gt;3840x2160&lt;/option&gt;
      &lt;option&gt;2560x1440&lt;/option&gt;
      &lt;option&gt;1920x1080&lt;/option&gt;
      &lt;option&gt;1280x720&lt;/option&gt;
      &lt;option selected&gt;800x600&lt;/option&gt;
      &lt;option&gt;640x480&lt;/option&gt;
      &lt;option&gt;320x240&lt;/option&gt;
      &lt;option value=" x "&gt;none&lt;/option&gt;
    &lt;/select&gt;
  &lt;/li&gt;
  &lt;li&gt;
    &lt;label for="framerate"&gt;Select a framerate&lt;/label&gt;
    &lt;select id="framerate"&gt;
      &lt;option&gt;60&lt;/option&gt;
      &lt;option&gt;50&lt;/option&gt;
      &lt;option&gt;30&lt;/option&gt;
      &lt;option&gt;24&lt;/option&gt;
      &lt;option selected&gt;15&lt;/option&gt;
    &lt;/select&gt;
  &lt;/li&gt;
    &lt;li&gt;
    &lt;label for="bitrate"&gt;Select a bitrate&lt;/label&gt;
    &lt;select id="bitrate"&gt;
      &lt;option&gt;4000&lt;/option&gt;
      &lt;option&gt;2500&lt;/option&gt;
      &lt;option&gt;800&lt;/option&gt;
    &lt;/select&gt;
  &lt;/li&gt;
  &lt;/ul&gt;
  &lt;p&gt;&lt;input type="button" value="Test this Video Configuration" id="tryit"&gt;&lt;/p&gt;
&lt;/form&gt;

&lt;ul id="results"&gt;&lt;/ul&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js;">let mc = {
  videoConfiguration : new Object(),

  tryit: function () {
   mc.createConfiguration();
   mc.testit();
  },

  createConfiguration: function () {
    var size = document.getElementById('size').value.split('x');
    mc.videoConfiguration = {
      type: 'file',
      video: {
        contentType: document.getElementById('codec').value,
        width: size[0],
        height: size[1],
        bitrate: document.getElementById('bitrate').value,
        framerate: document.getElementById('framerate').value,
      }
    }
  },

  testit: function () {
    let content = '';
    navigator.mediaCapabilities.decodingInfo(mc.videoConfiguration).then(result =&gt; {
      var li = document.createElement('li'),
        mcv = mc.videoConfiguration.video;
      content = 'A ' + mcv.width + 'x' + mcv.height + ', ' + mcv.contentType + ' at ' +
        mcv.framerate  + 'fps and ' +  mcv.bitrate + ' bps video ' +
        (result.supported ? ' IS ' : 'IS NOT ') + ' supported, ' +
        (result.smooth ? ' IS ' : ' is NOT ') + ' smooth, and' +
        (result.powerEfficient ? ' IS ' : ' IS NOT ') + 'power efficient.';
      var ul = document.getElementById("results")
      li.innerHTML = content;
      ul.appendChild(li);
    }).catch((error) =&gt; {
        var li = document.createElement('li'),
            ul = document.getElementById("results");
        li.innerText = 'Codec ' + mc.videoConfiguration.video.contentType + ' threw an error: ' + error;
        ul.appendChild(li);
    });
  }
}

document.getElementById('tryit').addEventListener('click', mc.tryit);</pre>

<h3 id="Live_Result">Live Result</h3>

<p>{{EmbedLiveSample('Media_Capabilities_live_example', '100%', '400')}}</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaCapabilities")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("navigator.mediaCapabilities")}}</li>
</ul>
